// ColorSpace.h: CColorSpace NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COLORSPACE_H__0BB39CE0_AB20_11D3_9BF6_00C0DFC4A6B8__INCLUDED_)
#define AFX_COLORSPACE_H__0BB39CE0_AB20_11D3_9BF6_00C0DFC4A6B8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


struct MRX {
	double m11,m12,
		   m21,m22;
} ;

struct GCS {
	int X,Y,Z;
};
/*
struct GCSi {
	int X,Y,Z; 
};
*/
class CColorSpace  
{
public:
	int maskRGB(int rgb);
	double distanceGCSd(GCS *g1,int x2,int y2,int z2) const;
	double distanceGCS(GCS *g1,GCS *g2) const;
	int convGCStoRGB(int X,int Y,int Z) const;
	void convRGBtoGCS(GCS *gcs,unsigned int rgb) const;
	void Create(int b,int r,int g,int p);


	CColorSpace();
	virtual ~CColorSpace();

protected:
	bool makeMatrix(MRX *a,MRX *b,double Cbm,double Crm,double Cgm);
	int maskRGBsub(int m[],int mc,int in,int s);
	void makeMatrixsub(MRX *M,MRX *N);

	MRX M1,M2;

	int masktabler[256],maskcountr;
	int masktableg[256],maskcountg;
	int masktableb[256],maskcountb;

//	double gammatable[256];
	double gtable[256];
	double r2table[256],g2table[256],b2table[256];

	int palettebitmask,palettebitmaskadd;
};

#endif // !defined(AFX_COLORSPACE_H__0BB39CE0_AB20_11D3_9BF6_00C0DFC4A6B8__INCLUDED_)
