// GraphArray.h: CGraphArray NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GRAPHARRAY_H__B64FE560_A7CD_11D3_9BF6_00C0DFC4A6B8__INCLUDED_)
#define AFX_GRAPHARRAY_H__B64FE560_A7CD_11D3_9BF6_00C0DFC4A6B8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
//#include <io.h>
//#include <direct.h>
#include "dibapi.h"
#include <afxadv.h>

class CGraphArray  
{
public:
	void ClearArray();
	unsigned long m_CRC[10];
	int m_CRCnum;
	HDIB m_hSourceDib;
	HDIB m_hDestinationDib;
	int m_palette[256];

	int PaletteVolume;

	HDIB DetachDestinationDib();
	int BitPerPixel;

	HDIB GetDestinationDib();
	HDIB GetSourceDib() const {return m_hSourceDib;};
	void SetSourceDib(HDIB hDib);
	BOOL ReverseArray(void);
	int* m_array;
	int Height;
	int Width;

	BOOL MakeArray();
	CGraphArray();
	virtual ~CGraphArray();

protected:

};

#endif // !defined(AFX_GRAPHARRAY_H__B64FE560_A7CD_11D3_9BF6_00C0DFC4A6B8__INCLUDED_)
