// MainFrm.cpp : CMainFrame NX̓̒`s܂B
//

#include "stdafx.h"
#include <atlbase.h>

#include "Padie.h"
#include "VerRes.h"
#include "CControllPanel.h"
#include "MainFrm.h"
#include "PadieDoc.h"
#include "SusiePlugin.h"
#include "OpenFileDialog.h"
#include "BatchDoc.h"
#include "BatchView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_COMMAND(ID_WINDOW_CASCADE, OnWindowCascade)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_COMMAND(ID_WINDOW_CLOSE_ALL, OnWindowCloseAll)
	ON_WM_PALETTECHANGED()
	ON_WM_QUERYNEWPALETTE()
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_UPDATE_COMMAND_UI(ID_DO_CANCEL, OnUpdateDoCancel)
	ON_COMMAND(ID_DO_CANCEL, OnDoCancel)
	ON_UPDATE_COMMAND_UI(ID_WINDOW_CLOSE_ALL, OnUpdateWindowCloseAll)
	ON_MESSAGE(WM_QUANT_THREAD_DONE, OnQuantThreadDone)
	ON_COMMAND(ID_FILE_PLUGIN, OnFilePlugin)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Xe[^X C CWP[^
//	ID_INDICATOR_PROGRESS,
/*
	ID_INDICATOR_KANA,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
*/
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/

CMainFrame::CMainFrame()
{
	// TODO: ̈ʒuɃȍR[hǉĂB

	m_wndProgressCtrlPosition=0;
}

CMainFrame::~CMainFrame()
{

}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_PadieClient.SubclassWindow (m_hWndMDIClient)) { // Add
		TRACE ("Failed to subclass MDI client window\n");   // Add
		return (-1);                                        // Add
	}   
	
	if (!m_wndToolBar.CreateEx(this,  TBSTYLE_FLAT | TBSTYLE_TRANSPARENT
		, WS_CHILD | WS_VISIBLE 
		| CBRS_TOP | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_FIXED) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // 쐬Ɏs
	}

	{/// tJ[c[o[`bvɓւ
		CBitmap *bmp,*bmpg,*bmpf;

		bmp=new CBitmap();
		bmp->LoadBitmap(IDB_BITMAP_BAR);
		bmpg=new CBitmap();
		bmpg->LoadBitmap(IDB_BITMAP_BAR_GRAY);
		bmpf=new CBitmap();
		bmpf->LoadBitmap(IDB_BITMAP_BAR_FRAME);

		m_listBar.Create( 20,20,ILC_COLOR24 | ILC_MASK,0,10 );
		m_listBar.Add(bmp, RGB(128,0,0));
		m_listBarg.Create( 20,20,ILC_COLOR24 | ILC_MASK,0,10 );
		m_listBarg.Add(bmpg, RGB(128,0,0));
		m_listBarf.Create( 20,20,ILC_COLOR24 | ILC_MASK,0,10 );
		m_listBarf.Add(bmpf, RGB(128,0,0));

		m_wndToolBar.GetToolBarCtrl().SetImageList(&m_listBarg);
		m_wndToolBar.GetToolBarCtrl().SetHotImageList(&m_listBar);
		m_wndToolBar.GetToolBarCtrl().SetDisabledImageList(&m_listBarf);
		m_wndToolBar.GetToolBarCtrl().SetIndent(5);
		delete bmp;
		delete bmpg;
		delete bmpf;
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // 쐬Ɏs
	}

	m_dOpenFile=new COpenFileDialog(m_hWnd);
	m_dSaveFile=new CSaveFileDialog(m_hWnd);

	m_dOpenFile->Filter=
			"ׂẴt@C(*.*)|*.*|BMP t@C(*.bmp)|*.bmp";
	m_dOpenFile->DefaultExt="bmp";
	m_dOpenFile->FilterIndex=1;
	m_dSaveFile->Filter=
			"ׂẴt@C(*.*)|*.*|BMP t@C(*.bmp)|*.bmp";
	m_dSaveFile->DefaultExt="bmp";
	m_dSaveFile->FilterIndex=2;
//---------------------------------------------------------------------------------

    {///  WXgÕEBhEʒu擾
	    CWinApp*  pApp = AfxGetApp();
	    CRect  rcWindow;
		CVerRes		res;
		if (pApp->GetProfileString( "Infomation", "version") == res.GetProductVersionShort()) {
		    rcWindow.left   = pApp->GetProfileInt( "ViewSettings", "left", 0 );
		    rcWindow.top    = pApp->GetProfileInt( "ViewSettings", "top", 0 );
		    rcWindow.right  = pApp->GetProfileInt( "ViewSettings", "right", 0 );
		    rcWindow.bottom = pApp->GetProfileInt( "ViewSettings", "bottom", 0 );
		    //  EBhEʒuC
		    MoveWindow( rcWindow );
		    pApp->m_nCmdShow = pApp->GetProfileInt( "ViewSettings", "style", SW_SHOWNORMAL);


			//page1
			m_cpl.m_BitSet=pApp->GetProfileInt( "ControllPanel", "BitSet", 0 );
			m_cpl.m_numBit=pApp->GetProfileInt( "ControllPanel", "numBit", 0 );
			m_cpl.m_Add16=pApp->GetProfileInt( "ControllPanel", "Add16", 0 );
			m_cpl.m_DitherMode=pApp->GetProfileInt( "ControllPanel", "DitherMode", 0 );
			m_cpl.m_DitherLevel=pApp->GetProfileInt( "ControllPanel", "DitherLevel", 0 );

			//page2
			m_cpl.m_magCR=pApp->GetProfileInt( "ControllPanel", "magCR", 0 );
			m_cpl.m_magGM=pApp->GetProfileInt( "ControllPanel", "magGM", 0 );
			m_cpl.m_magWB=pApp->GetProfileInt( "ControllPanel", "magWB", 0 );
			m_cpl.m_magYB=pApp->GetProfileInt( "ControllPanel", "magYB", 0 );
			m_cpl.m_InBit=pApp->GetProfileInt( "ControllPanel", "InBit", 0 );
			m_cpl.m_OutBit=pApp->GetProfileInt( "ControllPanel", "OutBit", 0 );

			//page3
			m_cpl.m_TransMode=pApp->GetProfileInt( "ControllPanel", "TransMode", 0 );
			m_cpl.m_TransPosition=pApp->GetProfileInt( "ControllPanel", "TransPosition", 0 );

			//page4
			m_cpl.m_BatchFileType=pApp->GetProfileInt( "ControllPanel", "BatchFileType", 0 );
			m_cpl.m_BatchPath=pApp->GetProfileString( "ControllPanel", "BatchPath", 0 );
			m_cpl.m_GifMode=pApp->GetProfileInt( "ControllPanel", "GifMode", 0 );
			m_cpl.m_PngMode=pApp->GetProfileInt( "ControllPanel", "PngMode", 0 );

			LoadBarState("BarStatus");

			m_dOpenFile->InitialDir=pApp->GetProfileString( "FileOperation", "OpenDir", 0 );
			m_dSaveFile->InitialDir=pApp->GetProfileString( "FileOperation", "SaveDir", 0 );
			SusiePluginPath=pApp->GetProfileString( "FileOperation", "PluginPath", 0 );

		}
		else {
			((CPadieApp*)AfxGetApp()) ->OnAppAbout();
			m_dOpenFile->InitialDir="";
			m_dSaveFile->InitialDir="";

			//susie path
			GetAppPathName(SusiePluginPath);
			ExtractFileDir(SusiePluginPath);
			CRegKey reg;
			if (reg.Open(HKEY_CURRENT_USER,"Software\\Takechin\\Susie\\Plug-in")
				==ERROR_SUCCESS ) {
					char path[_MAX_PATH];
					unsigned long sz=_MAX_PATH;
					if (reg.QueryValue(path,"Path",&sz)==ERROR_SUCCESS) {
						SusiePluginPath=path;
					}
					reg.Close();
			}
		}
	}

	DragAcceptFiles(TRUE);

	//susie
	LoadSusiePlugins();

	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh


void CMainFrame::OnDestroy() 
{
    WINDOWPLACEMENT  wndpl;
    //  EBhEʒu擾
    GetWindowPlacement( &wndpl );
    //  WXgɕۑ
    CWinApp*  pApp = AfxGetApp();
	CVerRes		res;
    pApp->WriteProfileString( "Infomation", "version", res.GetProductVersionShort() );

    pApp->WriteProfileInt( "ViewSettings", "left",   wndpl.rcNormalPosition.left );
    pApp->WriteProfileInt( "ViewSettings", "top",    wndpl.rcNormalPosition.top );
    pApp->WriteProfileInt( "ViewSettings", "right",  wndpl.rcNormalPosition.right );
    pApp->WriteProfileInt( "ViewSettings", "bottom", wndpl.rcNormalPosition.bottom );
    pApp->WriteProfileInt( "ViewSettings", "style",  wndpl.showCmd );

	//page1
    pApp->WriteProfileInt( "ControllPanel", "BitSet", m_cpl.m_BitSet );
    pApp->WriteProfileInt( "ControllPanel", "numBit", m_cpl.m_numBit );
    pApp->WriteProfileInt( "ControllPanel", "Add16", m_cpl.m_Add16 );
    pApp->WriteProfileInt( "ControllPanel", "DitherMode", m_cpl.m_DitherMode );
    pApp->WriteProfileInt( "ControllPanel", "DitherLevel", m_cpl.m_DitherLevel );

	//page2
    pApp->WriteProfileInt( "ControllPanel", "magCR", m_cpl.m_magCR );
    pApp->WriteProfileInt( "ControllPanel", "magGM", m_cpl.m_magGM );
    pApp->WriteProfileInt( "ControllPanel", "magWB", m_cpl.m_magWB );
    pApp->WriteProfileInt( "ControllPanel", "magYB", m_cpl.m_magYB );
    pApp->WriteProfileInt( "ControllPanel", "InBit", m_cpl.m_InBit );
    pApp->WriteProfileInt( "ControllPanel", "OutBit", m_cpl.m_OutBit );

	//page3
    pApp->WriteProfileInt( "ControllPanel", "TransMode", m_cpl.m_TransMode );
    pApp->WriteProfileInt( "ControllPanel", "TransPosition", m_cpl.m_TransPosition );

	//page4
    pApp->WriteProfileInt( "ControllPanel", "BatchFileType", m_cpl.m_BatchFileType );
    pApp->WriteProfileString( "ControllPanel", "BatchPath", m_cpl.m_BatchPath );
    pApp->WriteProfileInt( "ControllPanel", "GifMode", m_cpl.m_GifMode );
    pApp->WriteProfileInt( "ControllPanel", "PngMode", m_cpl.m_PngMode );

	SaveBarState("BarStatus");

	pApp->WriteProfileString( "FileOperation", "OpenDir", m_dOpenFile->InitialDir );
	pApp->WriteProfileString( "FileOperation", "SaveDir", m_dSaveFile->InitialDir );
	delete m_dOpenFile;
	delete m_dSaveFile;
	pApp->WriteProfileString( "FileOperation", "PluginPath", SusiePluginPath );

	FreeSusiePlugins();


	DragAcceptFiles(FALSE);
    //  X[p[NXOnDestroy()ĂԑOɏ
	CMDIFrameWnd::OnDestroy();

}

void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
	CMDIFrameWnd::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	{/// vOXo[ʒu␳
		RECT rect;
//		int index=m_wndStatusBar.CommandToIndex(ID_INDICATOR_PROGRESS);
//		m_wndStatusBar.SetPaneInfo(index,ID_INDICATOR_PROGRESS,SBPS_DISABLED | SBPS_NOBORDERS,200);
		m_wndStatusBar.GetItemRect(0/*index*/,&rect);
		rect.left=rect.right/2;
//		rect.top++, rect.left++, rect.bottom--, rect.right--;
		if (!m_wndProgressCtrl) {
			m_wndProgressCtrl.Create(WS_CHILD|WS_VISIBLE|PBS_SMOOTH ,rect,&m_wndStatusBar,(unsigned int)IDC_STATIC);
			m_wndProgressCtrl.SetRange(0,1000);
		}
		else {
			m_wndProgressCtrl.MoveWindow(&rect);
		}
		m_wndProgressCtrl.SetPos(m_wndProgressCtrlPosition);
	}
}

void CMainFrame::OnWindowCascade() 
{
	MDICascade(MDITILE_SKIPDISABLED);
	SendMessageToDescendants(WM_RESIZE_TO_FIT);
}

////////////////////////////////////////////////////////////////////////////////////

void CMainFrame::OnPaletteChanged(CWnd* pFocusWnd) 
{
	CMDIFrameWnd::OnPaletteChanged(pFocusWnd);

	// ANeBu r[pɏɃpbg܂B
	CMDIChildWnd* pMDIChildWnd = MDIGetActive();
	if (pMDIChildWnd == NULL)
		return; // ANeBu MDI qt[͂܂B
	CView* pView = pMDIChildWnd->GetActiveView();
	ASSERT(pView != NULL);

	// pbgύXꂽƂׂĂ̎qEBhE֒ʒm܂B
	SendMessageToDescendants(WM_DOREALIZE, (WPARAM)pView->m_hWnd);
}

BOOL CMainFrame::OnQueryNewPalette() 
{
	// ANeBu r[pɏɃpbg܂B
	CMDIChildWnd* pMDIChildWnd = MDIGetActive();
	if (pMDIChildWnd == NULL)
		return FALSE; // ANeBu MDI qt[͂܂ (VpbgȂ)
	CView* pView = pMDIChildWnd->GetActiveView();
	ASSERT(pView != NULL);

	// ^[Qbg̃r[ɂʒm܂B
	pView->SendMessage(WM_DOREALIZE, (WPARAM)pView->m_hWnd);
	return TRUE;
}

void CMainFrame::OnEditPaste() 
{
	/// Nbv{[hVKp
	HDIB hNewDIB = NULL;

	if (OpenClipboard())
	{
		BeginWaitCursor();

		hNewDIB = (HDIB) CopyHandle(::GetClipboardData(CF_DIB));

		CloseClipboard();
		if (hNewDIB != NULL)
		{
			LPSTR lpDIB = (LPSTR) ::GlobalLock((HGLOBAL) hNewDIB);
			((CPadieApp *)AfxGetApp())->m_stockSize = CSize((int) ::DIBWidth(lpDIB), (int) ::DIBHeight(lpDIB));
			::GlobalUnlock((HGLOBAL) hNewDIB);

			CPadieDoc *pd;
			pd=(CPadieDoc*)(theQuantSign.m_graphdoc->OpenDocumentFile(NULL));
			pd->SetPathName(_T("Clipboard"),FALSE);
			pd->StuffDocument(hNewDIB);
		}
		EndWaitCursor();
	}
}

void CMainFrame::OnUpdateEditPaste(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(::IsClipboardFormatAvailable(CF_DIB));	
}

void CMainFrame::OnWindowCloseAll() 
{
	CPadieDoc *pDoc;
	POSITION pos=theQuantSign.m_graphdoc->GetFirstDocPosition();
	if (pos) while ((pDoc=(CPadieDoc*)theQuantSign.m_graphdoc->GetNextDoc(pos))!=NULL) {
		if (! pDoc->m_Lock) pDoc->OnCloseDocument();
		if (!pos) break;
	}

}

LRESULT CMainFrame::OnQuantThreadDone(WPARAM pvParam, LPARAM )
{
	((CPadieDoc*)pvParam) ->QuantThreadDone();

	m_wndStatusBar.SendMessage(WM_SETTEXT,0,(LPARAM)_T("@"));

	return 0L;
}


void CMainFrame::OnFileOpen() 
{

	m_dOpenFile->FileName="";
	if (m_dOpenFile->Execute()) {
		if (m_dOpenFile->Files->GetCount()<2) {
			theQuantSign.m_graphdoc->OpenDocumentFile(m_dOpenFile->FileName);
		}
		else {
			CBatchDoc *pDoc;

			pDoc=(CBatchDoc*)theQuantSign.m_batchdoc->OpenDocumentFile(NULL);
			pDoc->StuffDocument(m_dOpenFile->Files);
			pDoc->SetPathName(_T("Batch"),FALSE);
		}


	}
	
}

void CMainFrame::AsFileOpen()
{
	OnFileOpen();
}

void CMainFrame::OnUpdateDoCancel(CCmdUI* pCmdUI) 
{
	if (theQuantSign.m_ThreadBeing) pCmdUI->Enable(TRUE);
	else pCmdUI->Enable(FALSE);
}

void CMainFrame::OnDoCancel() 
{
	theQuantSign.m_Terminated=TRUE;	
}

void CMainFrame::OnUpdateWindowCloseAll(CCmdUI* pCmdUI) 
{
	if (MDIGetActive()) pCmdUI->Enable(TRUE);
	else pCmdUI->Enable(FALSE);
}



void CMainFrame::OnFilePlugin() 
{
	CSusieDialog m_SusieDialog;
	
	m_SusieDialog.DoModal();

}
