// MyPropertyPage1.cpp : Cve[V t@C
//

#define _WIN32_IE 0x0200

#include "stdafx.h"
#include "resource.h"
#include "MyPropertyPage1.h"
#include "folder.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CMyPropertyPage1, CPropertyPage)
IMPLEMENT_DYNCREATE(CMyPropertyPage2, CPropertyPage)
IMPLEMENT_DYNCREATE(CMyPropertyPage3, CPropertyPage)
IMPLEMENT_DYNCREATE(CMyPropertyPage4, CPropertyPage)


/////////////////////////////////////////////////////////////////////////////
// CMyPropertyPage1 vpeB y[W

CMyPropertyPage1::CMyPropertyPage1() : CPropertyPage(CMyPropertyPage1::IDD)
{
	//{{AFX_DATA_INIT(CMyPropertyPage1)
	m_Add16 = FALSE;
	m_DitherMode = 0;
	m_numBit = 64;
	m_BitSet = 0;
	m_DitherLevel = 7;
	//}}AFX_DATA_INIT
}

CMyPropertyPage1::~CMyPropertyPage1()
{
}

void CMyPropertyPage1::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyPropertyPage1)
	DDX_Check(pDX, IDC_CHECK_ADD16, m_Add16);
	DDX_CBIndex(pDX, IDC_COMBO_DITHER, m_DitherMode);
	DDX_Text(pDX, IDC_EDIT_NBIT, m_numBit);
	DDV_MinMaxInt(pDX, m_numBit, 2, 256);
	DDX_Radio(pDX, IDC_RADIO_8BIT, m_BitSet);
	DDX_Slider(pDX, IDC_SLIDER_DITHER, m_DitherLevel);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMyPropertyPage1, CPropertyPage)
	//{{AFX_MSG_MAP(CMyPropertyPage1)
	ON_EN_SETFOCUS(IDC_EDIT_NBIT, OnSetfocusEditNbit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMyPropertyPage2 vpeB y[W

CMyPropertyPage2::CMyPropertyPage2() : CPropertyPage(CMyPropertyPage2::IDD)
{
	//{{AFX_DATA_INIT(CMyPropertyPage2)
	m_InBit = 3;
	m_OutBit = 8;
	m_magCR = 10;
	m_magGM = 10;
	m_magWB = 10;
	m_magYB = 10;
	//}}AFX_DATA_INIT
}

CMyPropertyPage2::~CMyPropertyPage2()
{
}

void CMyPropertyPage2::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyPropertyPage2)
	DDX_CBIndex(pDX, IDC_COMBO_INBIT, m_InBit);
	DDX_CBIndex(pDX, IDC_COMBO_OUTBIT, m_OutBit);
	DDX_Slider(pDX, IDC_SLIDER_CR, m_magCR);
	DDX_Slider(pDX, IDC_SLIDER_GM, m_magGM);
	DDX_Slider(pDX, IDC_SLIDER_WB, m_magWB);
	DDX_Slider(pDX, IDC_SLIDER_YB, m_magYB);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMyPropertyPage2, CPropertyPage)
	//{{AFX_MSG_MAP(CMyPropertyPage2)
	ON_BN_CLICKED(IDC_BUTTON_ENGINE_DEFAULT, OnButtonEngineDefault)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMyPropertyPage3 vpeB y[W

CMyPropertyPage3::CMyPropertyPage3() : CPropertyPage(CMyPropertyPage3::IDD)
{
	//{{AFX_DATA_INIT(CMyPropertyPage3)
	m_TransMode = FALSE;
	m_TransPosition = 3;
	//}}AFX_DATA_INIT
}

CMyPropertyPage3::~CMyPropertyPage3()
{
}

void CMyPropertyPage3::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyPropertyPage3)
	DDX_Check(pDX, IDC_CHECK_TRANS, m_TransMode);
	DDX_Radio(pDX, IDC_RADIO_TRANS_TL, m_TransPosition);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMyPropertyPage3, CPropertyPage)
	//{{AFX_MSG_MAP(CMyPropertyPage3)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMyPropertyPage4 vpeB y[W

CMyPropertyPage4::CMyPropertyPage4() : CPropertyPage(CMyPropertyPage4::IDD)
{
	//{{AFX_DATA_INIT(CMyPropertyPage4)
	m_PngMode = FALSE;
	m_GifMode = 0;
	m_BatchPath = _T("");
	m_BatchFileType = 0;
	//}}AFX_DATA_INIT
}

CMyPropertyPage4::~CMyPropertyPage4()
{
}

void CMyPropertyPage4::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyPropertyPage4)
	DDX_Check(pDX, IDC_CHECK_PNG_INTERLACE, m_PngMode);
	DDX_CBIndex(pDX, IDC_COMBO_GIF_INTERLACE, m_GifMode);
	DDX_Text(pDX, IDC_EDIT_BATCH_FOLDER, m_BatchPath);
	DDX_Radio(pDX, IDC_RADIO_BATCH_BMP, m_BatchFileType);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMyPropertyPage4, CPropertyPage)
	//{{AFX_MSG_MAP(CMyPropertyPage4)
	ON_BN_CLICKED(IDC_BUTTON_BATCH_BROWSE, OnButtonBatchBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
void CMyPropertyPage4::OnButtonBatchBrowse() 
{
	CString s;
	UpdateData(TRUE);
	if (GetDirectoryPath(this,s,m_BatchPath)) {
		m_BatchPath=s;
		UpdateData(FALSE);
	}
}

BOOL CMyPropertyPage1::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_wndDitherLevel.SubclassDlgItem(IDC_SLIDER_DITHER,this);
	m_wndDitherLevel.SetRange(0,10,TRUE);
	m_wndDitherLevel.SetTicFreq(1);
	m_wndDitherLevel.SetPageSize(1);
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

BOOL CMyPropertyPage2::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_wndMagCR.SubclassDlgItem(IDC_SLIDER_CR,this);
	m_wndMagCR.SetRange(0,20,TRUE);
	m_wndMagCR.SetTicFreq(2);
	m_wndMagCR.SetPageSize(1);
	m_wndMagGM.SubclassDlgItem(IDC_SLIDER_GM,this);
	m_wndMagGM.SetRange(0,20,TRUE);
	m_wndMagGM.SetTicFreq(2);
	m_wndMagGM.SetPageSize(1);
	m_wndMagWB.SubclassDlgItem(IDC_SLIDER_WB,this);
	m_wndMagWB.SetRange(0,20,TRUE);
	m_wndMagWB.SetTicFreq(2);
	m_wndMagWB.SetPageSize(1);
	m_wndMagYB.SubclassDlgItem(IDC_SLIDER_YB,this);
	m_wndMagYB.SetRange(0,20,TRUE);
	m_wndMagYB.SetTicFreq(2);
	m_wndMagYB.SetPageSize(1);
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CMyPropertyPage1::OnSetfocusEditNbit() 
{
	m_BitSet=3;
	UpdateData(FALSE);
}

void CMyPropertyPage2::OnButtonEngineDefault() 
{
	m_InBit = 3;
	m_OutBit = 8;
	m_magCR = 10;
	m_magGM = 10;
	m_magWB = 10;
	m_magYB = 10;
	UpdateData(FALSE);
}


