// Quant.cpp: CQuant NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CRTDBG.H"

#include "padie.h"
#include "MainFrm.h"
#include "Quant.h"
#include "ColorSpace.h"
#include <math.h>
#include <FLOAT.H>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif



static int fbpattern[2][3]={
	{ 3,5,1 },
	{ 7,0,0 }
};
static int maempattern[3][5]={
	{ 1,3,5,3,1 },
    { 3,5,7,5,3 },
    { 5,7,0,0,0 }
};

//////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
#include <limits.h>
#define CRCPOLY1 0x04C11DB7UL
	/* x^{32}+x^{26}+x^{23}+x^{22}+x^{16}+x^{12}+x^{11]+
	   x^{10}+x^8+x^7+x^5+x^4+x^2+x^1+1 */
#define CRCPOLY2 0xEDB88320UL  /* Et] */
typedef unsigned char byte;
unsigned long crctable[UCHAR_MAX + 1];

static void makecrctable(void)
{
	unsigned int i, j;
	unsigned long r;

	for (i = 0; i <= UCHAR_MAX; i++) {
		r = i;
		for (j = 0; j < CHAR_BIT; j++)
			if (r & 1) r = (r >> 1) ^ CRCPOLY2;
			else       r >>= 1;
		crctable[i] = r;
	}
}

static unsigned long crc(int n, byte c[])
{
	unsigned long r;

	r = 0xFFFFFFFFUL;
	while (--n >= 0)
		r = (r >> CHAR_BIT) ^ crctable[(byte)r ^ *c++];
	return r ^ 0xFFFFFFFFUL;
}
#endif
//////////////////////////////////////////////////////////////////////
static void  array_hsort(int *ab, int n) {
	int* a=ab-1;
	int i, j, k;
	int x;

	for (k = n / 2; k >= 1; k--) {
		i = k;  x = a[i];
		while ((j = 2 * i) <= n) {
			if (j < n && (((*(a+j)) & 0xfeffffff) < ((*(a+j+1)) & 0xfeffffff))) j++;
			if ((x & 0xfeffffff) >= ((*(a+j)) & 0xfeffffff)) break;
			a[i] = a[j];  i = j;
		}
		a[i] = x;
	}
	while (n > 1) {
		x = a[n];  a[n] = a[1];  n--;
		i = 1;
		while ((j = 2 * i) <= n) {
			if (j < n && (((*(a+j)) & 0xfeffffff) < ((*(a+j+1)) & 0xfeffffff))) j++;
			if ((x & 0xfeffffff) >= ((*(a+j)) & 0xfeffffff)) break;
			a[i] = a[j];  i = j;
		}
		a[i] = x;
	}

}

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CQuant::CQuant()
{

}

CQuant::~CQuant()
{

}
void CQuant::SetProgPos(int i)
{
	theQuantSign.m_ProgPosition=i;
}

void CQuant::PostReturnMessage()
{
	((CMainFrame*)((CMDIFrameWnd*)AfxGetApp()->m_pMainWnd))->PostMessage(WM_QUANT_THREAD_DONE,(WPARAM)pvParam);
}

//////////////////////////////////////////////////////////////////////
//---------------------------------------------------------------------------
/*
static int qsortsub(const void *a,const void *b)
{
	return ((*(int *)a) & 0xfeffffff)-((*(int *)b) & 0xfeffffff);
}
*/
//---------------------------------------------------------------------------
static int qsortpal(const void *a,const void *b)
{
	return (((PALSTR *)a)->z)-(((PALSTR *)b)->z);
}
//---------------------------------------------------------------------------
static int qsortanime(const void *a,const void *b)
{
	int n=(((Anime2line *)a)->d)-(((Anime2line *)b)->d);
	if (n>0) return 1;
	if (n<0) return -1;
	return (((Anime2line *)a)->pal)-(((Anime2line *)b)->pal);
}
//---------------------------------------------------------------------------

int CQuant::Execute()
{
	/*
		͂̓ô݁BOɓo^Ă邱ƁB
		o͂GlobalAllocDestinationDIB̂݁B̑͐mہAIjB
	*/

	CGraphArray &cg=pvParam->m_GraphArray;
	cg.MakeArray();

	int i;
	int colorcount;
	int *tmpbuf;
	GCS *dt[3];

	//	int pal[256];
	PALSTR pal[256];

	double wrapmx[13],wrapmn[13];
//	double allmidx,allmidy,allmidz;

	double wrapsign[13][3]= {
		{  1, 0, 0 },
		{  0, 1, 0 },
		{  0, 0, 1 },
		{  1, 1, 0 },
		{  1, 0, 1 },
		{  1, 0,-1 },
		{  1,-1, 0 },
		{  0, 1, 1 },
		{  0, 1,-1 },
		{  1, 1, 1 },
		{  1,-1, 1 },
		{  1,-1,-1 },
		{  1, 1,-1 }
	};


	theQuantSign.m_Terminated=false;

	tmpbuf=NULL;
	medbuf=NULL;
	smedbuf=NULL;

	for (i=0;i<256;i++) pal[i].z=INT_MAX;

	BOOL pictureconvertfinish=FALSE;

	SetProgPos(BARCR/4+BARCO);

	for (i=0;i<CUBEALL;i++) qcube[i]=NULL;
	dt[0]=dt[1]=dt[2]=NULL;

	/*if (integratedpalette==true)*/ {
//		orgbuf=info->picture_info[0].in_buf;
//		palbuf=info->picture_info[0].out_buf;
//		picx=info->picture_info[0].x;
//		picy=info->picture_info[0].y;

		picx=pvParam->m_GraphArray.Width;
		picy=pvParam->m_GraphArray.Height;
		orgbuf=pvParam->m_GraphArray.m_array;
		palbuf=(unsigned char*)malloc(picx*picy*sizeof(unsigned char));




	}

#ifdef _DEBUG
{
	makecrctable();
	cg.m_CRC[cg.m_CRCnum++]=crc(picx*picy*sizeof(int),(unsigned char*)orgbuf);
}
#endif



	picbuf=(int*)malloc(picx*picy*sizeof(int) ); //LpbgΉ

	makepalettenum=indexvolume;
	if (add16palette==TRUE) makepalettenum-=16;
	if (transparencycolor>=0) {
		makepalettenum--;
		switch (transparencycolor) {
			case 0:
				trans=orgbuf[0];
				break;
			case 1:
				trans=orgbuf[(picy-1)*picx];
				break;
			case 2:
				trans=orgbuf[picx-1];
				break;
			default:
				trans=orgbuf[picx*picy-1];
				break;
		}
	}
	else
		trans=0x01000000;

	// e[u쐻

//	ColorSpaceType=1;
	cs.Create(CbMag,CrMag,CgMag,paletteprecision);

/*	if (recycle==false)*/ {
		long adp=0;
	   	int m,r,rgb,t[256];
		int loop,lp;
		int k,i,j,c,ct;

//		loop=(integratedpalette==false)?1:info->num;
		loop=1;

		m=0xff & ~picturemask;
	   	k=(picturemask+1)/2;
		for (i=0;i<256;i++) {
			r=i+k;
			if (r>255) r=255;
			r&=m;
			t[i]=r;
		}

	   	for (i=0;i<makepalettenum;i++) pal[i].c=0;
		for (lp=0;lp<loop;lp++) {

/*			if (integratedpalette==true) {
				orgbuf=info->picture_info[lp].in_buf;
				picx=info->picture_info[lp].x;
				picy=info->picture_info[lp].y;
			}
*/
#define nEDGE 0
//------------------------------------------------------------------------------
#if nEDGE==0
	// ֊s
				#define colortrim1(n) (unsigned char)(max(0.,min(255.,n)))
	{

		int sobel1[9]={
			 1, 0,-1,
			 2, 0,-2,
			 1, 0,-1};
		int sobel2[9]={
			 1, 2, 1,
			 0, 0, 0,
			-1,-2,-1};

		unsigned char *tmpbuf;
		int r,g,b,rm,gm,bm;
		int rx,gx,bx;
		int c;
		int dx,dy,x,y;
		int rmx,rmn,gmx,gmn,bmx,bmn;

		int ry,gy,by;
		int sa;

		tmpbuf=(unsigned char *)malloc(picx*picy*6*sizeof(unsigned char));
		memset(tmpbuf,0,picx*picy*6*sizeof(unsigned char));

		for (y=0;y<picy;y++) {
			for (x=0;x<picx;x++) {
				if (x>0 && x<picx-1 && y>0 && y<picy-1) {

					rx=0,gx=0,bx=0;
					ry=0,gy=0,by=0;
					rmx=0,gmx=0,bmx=0;
					rmn=1000,gmn=1000,bmn=1000;

					c=orgbuf[(x)+(y)*picx];
					rm=(c)     & 0xff;
					gm=(c>>8)  & 0xff;
					bm=(c>>16) & 0xff;

					sa=0;
					for (dy=-1;dy<2;dy++) {
						for (dx=-1;dx<2;dx++) {
								c=orgbuf[(x+dx)+(y+dy)*picx];
								r=(c)     & 0xff;
								g=(c>>8)  & 0xff;
								b=(c>>16) & 0xff;
								rx+=sobel1[sa]*(r-rm);
								gx+=sobel1[sa]*(g-gm);
								bx+=sobel1[sa]*(b-bm);
								ry+=sobel2[sa]*(r-rm);
								gy+=sobel2[sa]*(g-gm);
								by+=sobel2[sa]*(b-bm);

								rmx=max(r,rmx);
								rmn=min(r,rmn);
								gmx=max(g,gmx);
								gmn=min(g,gmn);
								bmx=max(b,bmx);
								bmn=min(b,bmn);

								sa++;
						}
					}
					tmpbuf[(x+y*picx)*6+0]=colortrim1(128.-(double)rx/max(rmx-rmn,8)*64.);
					tmpbuf[(x+y*picx)*6+1]=colortrim1(128.-(double)ry/max(rmx-rmn,8)*64.);
					tmpbuf[(x+y*picx)*6+2]=colortrim1(128.-(double)gx/max(gmx-gmn,8)*64.);
					tmpbuf[(x+y*picx)*6+3]=colortrim1(128.-(double)gy/max(gmx-gmn,8)*64.);
					tmpbuf[(x+y*picx)*6+4]=colortrim1(128.-(double)bx/max(bmx-bmn,8)*64.);
					tmpbuf[(x+y*picx)*6+5]=colortrim1(128.-(double)by/max(bmx-bmn,8)*64.);
				}

			}
			if (theQuantSign.m_Terminated) {
				free(tmpbuf);
				goto endH;
			}
			SetProgPos(BARDR*y/picy+BARDO);	
		}




#ifdef _DEBUG
	{
		makecrctable();
		cg.m_CRC[cg.m_CRCnum++]=crc(picx*picy*6*sizeof(unsigned char),(unsigned char*)tmpbuf);
	}
#endif
	{
		double r,g,b;
		int rx,ry,gx,gy,bx,by;
		int rxm,rym,gxm,gym,bxm,bym;
		int mm;

		int ta=0,tb=0;

		for (y=0;y<picy;y++) {
			for (x=0;x<picx;x++) {

				if (x>0 && x<picx-1 && y>0 && y<picy-1) {

					rxm=tmpbuf[(x+y*picx)*6+0];
					rym=tmpbuf[(x+y*picx)*6+1];
					gxm=tmpbuf[(x+y*picx)*6+2];
					gym=tmpbuf[(x+y*picx)*6+3];
					bxm=tmpbuf[(x+y*picx)*6+4];
					bym=tmpbuf[(x+y*picx)*6+5];

					r=0, g=0, b=0;

					for (dy=-1;dy<2;dy++) {
						for (dx=-1;dx<2;dx++) {
								rx=tmpbuf[((x+dx)+(y+dy)*picx)*6+0];
								ry=tmpbuf[((x+dx)+(y+dy)*picx)*6+1];
								gx=tmpbuf[((x+dx)+(y+dy)*picx)*6+2];
								gy=tmpbuf[((x+dx)+(y+dy)*picx)*6+3];
								bx=tmpbuf[((x+dx)+(y+dy)*picx)*6+4];
								by=tmpbuf[((x+dx)+(y+dy)*picx)*6+5];

								r+=sqrt((rx-rxm)*(rx-rxm)+(ry-rym)*(ry-rym));
								g+=sqrt((gx-gxm)*(gx-gxm)+(gy-gym)*(gy-gym));
								b+=sqrt((bx-bxm)*(bx-bxm)+(by-bym)*(by-bym));
						}
					}
					mm=colortrim1(255-sqrt(r*r+g*g+b*b)/8);
					mm=(mm<160)?0:255;
				}
				else mm=0;

				if ((rgb=orgbuf[x+y*picx])!=trans) {
					if (mm==0) {
						picbuf[x+y*picx+adp]=t[rgb & 0xff] | (t[(rgb & 0xff00)>>8]<<8) | (t[(rgb & 0xff0000)>>16]<<16);
						ta++;
					}
					else {
						picbuf[x+y*picx+adp]=t[rgb & 0xff] | (t[(rgb & 0xff00)>>8]<<8) | (t[(rgb & 0xff0000)>>16]<<16) | 0x01000000;
						tb++;
					}
				}
				else

					picbuf[x+y*picx+adp]=0x40000000;

			}
			if (theQuantSign.m_Terminated) {
				free(tmpbuf);
				goto endH;
			}
			SetProgPos(BARER*y/picy+BAREO);


		}
		if (tmpbuf) free(tmpbuf), tmpbuf=NULL;
  //	MessageBox(Application->Handle,(AnsiString(ta)+"/"+AnsiString(tb)).c_str(),"dݕt",MB_ICONINFORMATION);


	}}
#endif
//------------------------------------------------------------------------------
#if nEDGE==1
			j=i=picx*picy;
			// oFƂ̉
			for (i=0;i<j;i++) {
				if ((rgb=orgbuf[i])!=trans)
					picbuf[i+adp]=t[rgb & 0xff] | (t[(rgb & 0xff00)>>8]<<8) | (t[(rgb & 0xff0000)>>16]<<16);
				else
					picbuf[i+adp]=0x40000000;
			}
#endif
//------------------------------------------------------------------------------

			adp+=picx*picy;
		}
		tmpbuf=(int*)malloc(adp*2*sizeof(int));


#ifdef _DEBUG
	{
		makecrctable();
		cg.m_CRC[cg.m_CRCnum++]=crc(adp*sizeof(int),(unsigned char*)picbuf);
	}
#endif

//		qsort(picbuf,adp,sizeof(int),qsortsub);
		array_hsort(picbuf,adp);


		c=picbuf[0] & 0xffffff;
		ct=1;
		colorcount=0;
		for (i=1;i<adp;i++) {
			if (c!=(k=picbuf[i])) {
				tmpbuf[colorcount*2]=ct;
				tmpbuf[(colorcount++)*2+1]=c;
				c=k & 0xffffff;
				ct=0;
			}
			if ((k & 0x1000000)>0) ct+=8; else ct+=1;
		}
		if (c!=0x40000000) {
			tmpbuf[colorcount*2]=ct;
			tmpbuf[(colorcount++)*2+1]=c;
		}
		if (theQuantSign.m_Terminated) goto endH;

		SetProgPos(BARFR/2+BARFO);

		// median cutpԂ쐻
		medbuf=  (MED*) malloc(colorcount*sizeof(MED ));
		smedbuf= (MED**)malloc(colorcount*sizeof(MED*));
		for (i=0;i<colorcount;i++) {
			j=tmpbuf[i*2+1];
			medbuf[i].cnt=tmpbuf[i*2];
			cs.convRGBtoGCS(&(medbuf[i].gcs),j);

			smedbuf[i]=&medbuf[i];
		}
		if (theQuantSign.m_Terminated) goto endH;
		if (tmpbuf) free(tmpbuf),tmpbuf=NULL;
	}

	if (theQuantSign.m_Terminated) goto endH;
	SetProgPos(BARFR+BARFO);

	// median cut ////////////////////////////////////////////////////////////////

/*	if (recycle==false)*/ {
		int i,j,k,mxa,ct,cl,f,makepal;
		double mx;

		dv.makeMEDbox(medbox,smedbuf,0,0,colorcount,&cs);

		if (theQuantSign.m_Terminated) goto endH;
		if (makepalettenum) SetProgPos(BARAR*1/makepalettenum+BARAO);
		i=1;
		makepal=0;
		while (makepal<makepalettenum && i<760) {
//			_RPT1(_CRT_WARN,"%d:",makepal);

			mx=medbox[mxa=0].strain;
			for (j=1;j<i;j++) {
				if (mx<medbox[j].strain) {
					mxa=j;
					mx=medbox[mxa].strain;
				}
			}

			if (mx>0) {
            	if (dv.divideBox(medbox,smedbuf,mxa,i,&cs)!=true) continue;
            }
			else break;
			i++;

			//pbg\[g

			//LpbgJEg
			ct=0;
		   	for (j=0;j<i;j++) {
				cl=medbox[j].rgb;
				f=TRUE;
				for (k=0;k<ct;k++) if (pal[k].c==cl) f=false;
				if (f==TRUE) {
					GCS a;
					cs.convRGBtoGCS(&a,cl);
					pal[ct].c=cl;
					pal[ct].z=a.Z;
					ct++;
				}
			}
			makepal=ct;

			if (theQuantSign.m_Terminated) goto endH;
			SetProgPos((int)(BARAR*( ( (1-1./sqrt(max(makepal,1))) /2) + ((double)makepal/makepalettenum/2.) )+BARAO));

		}

	}

	if (medbuf) free(medbuf),medbuf=NULL;
	if (smedbuf) free(smedbuf),smedbuf=NULL;

//--------------

	{
		int i,m;
		GCS a;
		int p[16]={
			0x000000,
			0x000080,
			0x008000,
			0x008080,
			0x800000,
			0x800080,
			0x808000,
			0x808080,
			0xc0c0c0,
			0x0000ff,
			0x00ff00,
			0x00ffff,
			0xff0000,
			0xff00ff,
			0xffff00,
			0xffffff };

		m=makepalettenum;
		if (add16palette==TRUE /*&& recycle==false*/) {
			for (i=0;i<16;i++) {
				pal[m+i].c=p[i];
				cs.convRGBtoGCS(&a,p[i]);
				pal[m+i].z=a.Z;
			}
			m+=16;
		}

		qsort(pal,m,sizeof(PALSTR),qsortpal);
	}

#ifdef _DEBUG
	{
		makecrctable();
		cg.m_CRC[cg.m_CRCnum++]=crc(makepalettenum*sizeof(PALSTR),(unsigned char*)pal);
	}
#endif

	// pbgXg쐻
	{
		int i,j,m,x,y,z;
		double tx=0,ty=0,tz=0;
		double d;

		m=makepalettenum;
		if (add16palette==TRUE) m+=16;
		for (i=0;i<m;i++) {
/*			if (recycle==true) {
				j=pal[i].c=madepalette[i];
			} else */{
				j=pal[i].c;
			}
			cs.convRGBtoGCS(&gcstable[i],j);

			tx+=x=gcstable[i].X;
			ty+=y=gcstable[i].Y;
			tz+=z=gcstable[i].Z;

			for (j=0;j<13;j++) {
				d=x*wrapsign[j][0]+y*wrapsign[j][1]+z*wrapsign[j][2];
				if (i==0) wrapmx[j]=wrapmn[j]=d;
				else {
					if (d<wrapmn[j]) wrapmn[j]=d;
					if (d>wrapmx[j]) wrapmx[j]=d;
				}
			}

		}



		mxdx=(int)(wrapmx[0]-wrapmn[0]);
		mxdy=(int)(wrapmx[1]-wrapmn[1]);
		mxdz=(int)(wrapmx[2]-wrapmn[2]);
	}
	if (theQuantSign.m_Terminated) goto endH;

	makepalettenum=indexvolume;
	if (transparencycolor>=0) {
		transpal=--makepalettenum;
		pal[makepalettenum].c=trans;
	}

	// convert graphics

	{
		int loop,lp;

//		loop=(integratedpalette==false)?1:info->num;
		loop=1;
		for (lp=0;lp<loop;lp++) {
/*			if (integratedpalette==true) {
				orgbuf=info->picture_info[lp].in_buf;
				palbuf=info->picture_info[lp].out_buf;
				picx=info->picture_info[lp].x;
				picy=info->picture_info[lp].y;
			}*/

			if (dithermode==0) {
				GCS gcs1;
				int i,x,y,k;

				for (y=0;y<picy;y++) {
					for (x=0;x<picx;x++) {
						i=orgbuf[x+y*picx];
						if (i==trans) {
							k=transpal;
						}
						else {
							cs.convRGBtoGCS(&gcs1,i);
							k=findClosepalette(gcs1.X,gcs1.Y,gcs1.Z);
						}
						palbuf[x+y*picx]=(unsigned char)k;
					}
					if (theQuantSign.m_Terminated) goto endH;
					SetProgPos(BARBR*y/picy+BARBO);
				}
			}
			else if (dithermode==2 || dithermode==3)
			{
				GCS gcs1;
				GCS *dttmp;
				int i,x,y,k,gx,gy,gz,dv,dvs,dx,dy,dz,sx,sy,m,kk;

				for (i=0;i<3;i++) {
					dt[i]=(GCS*)malloc((picx+4)*sizeof(GCS));
					memset(dt[i],0,sizeof(GCS)*(picx+4));
				}

				dv=1, dvs=-1;

				for (y=0;y<picy;y++) {
					for (x=((dv==1)?0:picx-1);x<picx && x>=0;x+=dv) {
						i=orgbuf[x+y*picx];
						if (i==trans) {
							k=transpal;
						}
						else {
							cs.convRGBtoGCS(&gcs1,i);

							dx=dy=dz=0;
							if (dithermode==2) {
								//FS
								for (sx=-1;sx<2;sx++) for (sy=0;sy<2;sy++) {
									if ((m=fbpattern[1-sy][sx+1])>0) {
										dx+=dt[sy][kk=x+2+sx*dv].X*m;
										dy+=dt[sy][kk].Y*m;
										dz+=dt[sy][kk].Z*m;
									}
								}
								dx/=160, dy/=160, dz/=160;
							}
							else {
								//maem
								for (sx=-2;sx<3;sx++) for (sy=0;sy<3;sy++) {
									if ((m=maempattern[2-sy][sx+2])>0) {
										dx+=dt[sy][kk=x+2+sx*dv].X*m;
										dy+=dt[sy][kk].Y*m;
										dz+=dt[sy][kk].Z*m;
									}
								}
                                dx/=480, dy/=480, dz/=480;
                            }

							if (dx>mxdx) dx=mxdx; else if (dx<-mxdx) dx=-mxdx;
							if (dy>mxdy) dy=mxdy; else if (dy<-mxdy) dy=-mxdy;
							if (dz>mxdz) dz=mxdz; else if (dz<-mxdz) dz=-mxdz;


							gx=gcs1.X+dx;
							gy=gcs1.Y+dy;
							gz=gcs1.Z+dz;
							k=findClosepalette(gx,gy,gz);
           					dt[0][x+2].X=(gx-gcstable[k].X)*ditherlevel;
							dt[0][x+2].Y=(gy-gcstable[k].Y)*ditherlevel;
							dt[0][x+2].Z=(gz-gcstable[k].Z)*ditherlevel;
						}

						palbuf[x+y*picx]=(unsigned char)k;
					}
					dttmp=dt[2]; dt[2]=dt[1]; dt[1]=dt[0]; dt[0]=dttmp;
	                memset(dt[0],0,sizeof(GCS)*(picx+4));

					if (theQuantSign.m_Terminated) goto endH;
					SetProgPos(BARBR*y/picy+BARBO);
					dv=dv*dvs;
				}
			}
            else if (dithermode==1) {
                Biscan(picx,picy);
            }
			else if (dithermode==4) {
				Mtscan(picx,picy);

			}

/*			{
				int i;
				for (i=0;i<indexvolume;i++) (info->picture_info[lp].palbuf)[i]=pal[i].c;
				//@F
				info->picture_info[lp].palnum=indexvolume;
			}
*/
			{
				int i;
				for (i=0;i<indexvolume;i++) pvParam->m_GraphArray.m_palette[i]=pal[i].c;
				pvParam->m_GraphArray.PaletteVolume=indexvolume;
				if (indexvolume<3) pvParam->m_GraphArray.BitPerPixel=1;
				else if (indexvolume<17) pvParam->m_GraphArray.BitPerPixel=4;
				else pvParam->m_GraphArray.BitPerPixel=8;
			}
		}//loop
	}

	pictureconvertfinish=TRUE;

//   	MessageBox(Form1->Handle,AnsiString(testcubetotal/testcubecount).c_str(),"Cube ave",MB_ICONINFORMATION);


endH:

#ifdef _DEBUG
	{
		makecrctable();
		cg.m_CRC[cg.m_CRCnum++]=crc(picx*picy,(unsigned char*)palbuf);
	}
#endif

	if (pictureconvertfinish) {
		int x,y;
		for (y=0;y<picy;y++) for (x=0;x<picx;x++) orgbuf[x+y*picx]=palbuf[x+y*picx];
		cg.ReverseArray();
	}
	else {
		cg.m_hDestinationDib=NULL;
	}


	cg.ClearArray();
	if (tmpbuf) free(tmpbuf);
	if (medbuf) free(medbuf);
	if (smedbuf) free(smedbuf),smedbuf=NULL;
	if (picbuf)	free(picbuf);
	if (palbuf) free(palbuf);
	for (i=0;i<CUBEALL;i++) if (qcube[i]) free(qcube[i]);
	for (i=0;i<3;i++) if (dt[i]) free(dt[i]);

//	return (pictureconvertfinish==true)?1:0;

	PostReturnMessage();
//	AfxEndThread(0,TRUE);
	return (0);
}



//---------------------------------------------------------------------------
// ŋߋpbgGLbVO
//---------------------------------------------------------------------------
int CQuant::getCubeadr(int x, int y, int z)
{
	int cx,cy,cz;

    cx=(x+CUBEH)/CUBESTEP;
    cy=(y+CUBEH)/CUBESTEP;
    cz=(z+CUBEZO)/CUBESTEP;

    if (cx<0 || cx>=CUBEX || cy<0 || cy>=CUBEY || cz<0 || cz>=CUBEZ) return -1;
    return (cz*CUBEY+cy)*CUBEX+cx;
}

int CQuant::findClosepaletteSub(short *p, int x, int y, int z)
{
	double mn,mt;
    int k=0 ,kk;
    GCS gcs2;
    short int *pt=p;

	gcs2.X=x;
	gcs2.Y=y;
	gcs2.Z=z;

	mn=DBL_MAX;
	while ((kk=*pt)>=0) {
		mt=cs.distanceGCS(&gcs2,&gcstable[kk]);
		if (mt<mn) {
			mn=mt;
			k=kk;
		}
		pt++;
	}
	return k;
}

void CQuant::makecube(int x, int y, int z)
{
	int c,a;
	short int *pt,i;
	double dt[256],d,mn;
	GCS gcs1;
	short int ap[256];
	int cx,cy,cz;

	a=getCubeadr(x,y,z);

	cx=(x+CUBEH)/CUBESTEP;
	cy=(y+CUBEH)/CUBESTEP;
	cz=(z+CUBEZO)/CUBESTEP;
	d=sqrt((double)CUBESTEP*CUBESTEP*3);
	gcs1.X=(int)(CUBESTEP*cx+CUBESTEPH-CUBEH);
	gcs1.Y=(int)(CUBESTEP*cy+CUBESTEPH-CUBEH);
	gcs1.Z=(int)(CUBESTEP*cz+CUBESTEPH-CUBEZO);

	mn=dt[0]=sqrt((double)cs.distanceGCS(&gcs1,&gcstable[0]));
	for (i=1;i<makepalettenum;i++) {
		if (mn>(dt[i]=sqrt((double)cs.distanceGCS(&gcs1,&gcstable[i])))) {
			mn=dt[i];
		}
	}
	c=0;
	for (i=0;i<makepalettenum;i++) {
		if (dt[i]<mn+d) {
			ap[c++]=i;
		}
	}
	pt=qcube[a]=(short int*)malloc((c+1)*sizeof(short int));
	for (i=0;i<c;i++) pt[i]=ap[i];
	pt[c]=-1;

}

int CQuant::findClosepalette(int x, int y, int z)
{
	int k,j,i;
	GCS gcs2;
	double mn,mt;

	i=getCubeadr(x,y,z);
	if (i<0) {
		gcs2.X=x;
		gcs2.Y=y;
		gcs2.Z=z;
		mn=cs.distanceGCS(&gcs2,&gcstable[k=0]);
		for (j=1;j<makepalettenum;j++) {
			if (mn>(mt=cs.distanceGCS(&gcs2,&gcstable[j]))) {
				mn=mt;
				k=j;
			}
		}
	}
	else {
		if (qcube[i]==NULL) makecube(x,y,z);
		k=findClosepaletteSub(qcube[i],x,y,z);
	}
	return k;
}

//---------------------------------------------------------------------------

void CQuant::Mtscan(int width, int height)
// Anime2Jn
{
	int x,y;
	int j,i,k,kk;
	int dx,dy,dz,gx,gy,gz;
	GCS gcs1;

	Anime2line a2l[32];


	char dit[16] = { 0, 8, 2,10, 12, 4,14, 6, 3,11, 1, 9,15, 7,13, 5 };
//	char dit[4] = {  0, 2 , 3, 1 };

	for (y=0;y<height;y++) {
		for (x=0;x<width;x++) {
			i=orgbuf[x+y*picx];
			if (i==trans) k=transpal;
			else {

				//16dither
				dx=dy=dz=0;
				cs.convRGBtoGCS(&gcs1,i);
				for (j=0;j<18;j++) {
					gx=gcs1.X+dx;
					gy=gcs1.Y+dy;
					gz=gcs1.Z+dz;
					a2l[j].pal=kk=findClosepalette(gx,gy,gz);
					a2l[j].d=	gcstable[kk].Z;

					dx=(gx-gcstable[kk].X)*ditherlevel/10;
					dy=(gy-gcstable[kk].Y)*ditherlevel/10;
					dz=(gz-gcstable[kk].Z)*ditherlevel/10;
				}
				//\[g
				qsort(&a2l,16,sizeof(Anime2line),qsortanime);

				//ditʒuƃ\[gʒu猈
				k=a2l[dit[(y & 3)*4+(x & 3)]].pal;
			}
			palbuf[x+y*picx]=(unsigned char)k;

		}
		if (theQuantSign.m_Terminated) return;
		SetProgPos(BARBR*y/height+BARBO);
	}

}

//---------------------------------------------------------------------------
/*
oT
	`摜̈ʉƂ̉p
	i] FK
	 3 N 2  16 
*/
#define even(_x_) (0==(_x_)% 2)
void CQuant::link(int a, int b)
// gPeanos
{
	int x,y,i,dx,dy,dz,k,gx,gy,gz;
	GCS gcs1;

	x=(gpsx+=a);
	y=(gpsy+=b);
	//덷܂ݏo

	i=orgbuf[x+y*picx];
	if (i==trans) {
		k=transpal;
	}
	else {
		cs.convRGBtoGCS(&gcs1,i);

		dx=gpsdx*ditherlevel/10;
		dy=gpsdy*ditherlevel/10;
        dz=gpsdz*ditherlevel/10;

		if (dx>mxdx) dx=mxdx; else if (dx<-mxdx) dx=-mxdx;
		if (dy>mxdy) dy=mxdy; else if (dy<-mxdy) dy=-mxdy;
		if (dz>mxdz) dz=mxdz; else if (dz<-mxdz) dz=-mxdz;

		gx=gcs1.X+dx;
		gy=gcs1.Y+dy;
		gz=gcs1.Z+dz;
		k=findClosepalette(gx,gy,gz);

       	gpsdx=gx-gcstable[k].X;
       	gpsdy=gy-gcstable[k].Y;
       	gpsdz=gz-gcstable[k].Z;
	}
	palbuf[x+y*picx]=(unsigned char)k;

    //progress set
	SetProgPos(BARBR*(gpsc++)/(picx*picy)+BARBO);

}

void CQuant::Transpose(int *a, int *b, int *c, int *d, int *e, int *f)
{
	int t;

	t = *a; *a = *b; *b = t;
	t = *c; *c = *d; *d = t;
	t = *e; *e = *f; *f = t;
}

void CQuant::Bic(int m, int n, int a, int b, int c, int d)
{
	int	m1, m2;

	m1 = m2 = m / 2;
	if(even(n) && even(m1)){ m1++; m2--; } // ؂ȂƂ̒
	Bit(m1, n, a, b, c, d);
	link(a, b);
	Bit(m2, n, a, b, - c, - d);
}

void CQuant::Bit(int m, int n, int a, int b, int c, int d)
{
	int	i;

	if(1 == m) for(i = 1; i < n; link(c, d), i++);
	else if(1 == n) for(i = 1; i < m; link(a, b), i++);
	else{
		int	m1, m2;

		if(m < n) Transpose(&m, &n, &a, &c, &b, &d);
		m1 = m2 = m / 2;
		switch(m % 4){	case 1: m2++; break;
				case 2: m1++; m2--; break;
				case 3: m1++; }
		Bic(m1, n, a, b, c, d);
		link(a, b);
		Bit(m2, n, a, b, c, d);
	}
}

void CQuant::Biscan(int width, int height)
// gPeanosJn
{
	gpsx=gpsy=gpsc=0;

    gpsdx=gpsdy=gpsdz=0;

    link(0,0);
	if(even(width) && even(height)){
		if(height > width) Bic(height, width, 0, 1, 1, 0);
		else		   Bic(width, height, 1, 0, 0, 1);
	}
	else			   Bit(width, height, 1, 0, 0, 1);
}



