// SusieDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "padie.h"
#include "SusieDialog.h"
#include "folder.h"
#include "SusiePlugin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSusieDialog _CAO


CSusieDialog::CSusieDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CSusieDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSusieDialog)
	m_PluginPath = _T("");
	//}}AFX_DATA_INIT
}


void CSusieDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSusieDialog)
	DDX_Control(pDX, IDC_LIST_PLUGIN_INVALID, m_InvalidList);
	DDX_Control(pDX, IDC_LIST_PLUGIN_VALID, m_ValidList);
	DDX_Text(pDX, IDC_EDIT_PLUGIN_FOLDER, m_PluginPath);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSusieDialog, CDialog)
	//{{AFX_MSG_MAP(CSusieDialog)
	ON_BN_CLICKED(IDC_BUTTON_PLUGIN_ADD, OnButtonPluginAdd)
	ON_BN_CLICKED(IDC_BUTTON_PLUGIN_FOLDER, OnButtonPluginFolder)
	ON_BN_CLICKED(IDC_BUTTON_PLUGIN_REMOVE, OnButtonPluginRemove)
	ON_BN_CLICKED(IDC_BUTTON_PLUGIN_SYNC, OnButtonPluginSync)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSusieDialog bZ[W nh

void CSusieDialog::OnButtonPluginAdd() 
{
	int pt[100];
	int n,i;
	CString s;

	n=m_InvalidList.GetSelItems(100,pt);
	if (n) {
		for (i=n-1;i>=0;i--) {
			m_InvalidList.GetText(pt[i],s);
			m_ValidList.AddString(s);
			m_InvalidList.DeleteString(pt[i]);
		}
	}
	
}
void CSusieDialog::OnButtonPluginRemove() 
{
	int pt[100];
	int n,i;
	CString s;

	n=m_ValidList.GetSelItems(100,pt);
	if (n) {
		for (i=n-1;i>=0;i--) {
			m_ValidList.GetText(pt[i],s);
			m_InvalidList.AddString(s);
			m_ValidList.DeleteString(pt[i]);
		}
	}


}
void CSusieDialog::OnButtonPluginFolder() 
{
	CString s;

	UpdateData(TRUE);
	if (GetDirectoryPath(this,s,m_PluginPath)) {
		m_PluginPath=s;
		UpdateData(FALSE);
		/// todo t@CČ
		RefreshList();
	}	
}

BOOL CSusieDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	m_PluginPath=SusiePluginPath;
	RefreshList();


	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}



void CSusieDialog::OnOK() 
{
	// vOCĐݒ
	UpdateData(TRUE);
	SusiePluginPath=m_PluginPath;
	
	CStringList lst;
	CString s;
	int i,n;
	n=m_InvalidList.GetCount();
	for (i=0;i<n;i++) {
		m_InvalidList.GetText(i,s);
		lst.AddTail(s);
	}
	SetSusiePluginsInvalid(&lst);

	FreeSusiePlugins();
	LoadSusiePlugins();
	
	CDialog::OnOK();
}

void CSusieDialog::RefreshList()
{

	{
		CStringList s;
		GetSusiePluginsValid(&s,m_PluginPath);
		m_ValidList.ResetContent();
		POSITION pos;

		for( pos = s.GetHeadPosition(); pos != NULL; ) {
			m_ValidList.AddString(s.GetNext(pos));
		}
	}
	{
		CStringList s;
		GetSusiePluginsInvalid(&s,m_PluginPath);
		m_InvalidList.ResetContent();
		POSITION pos;

		for( pos = s.GetHeadPosition(); pos != NULL; ) {
			m_InvalidList.AddString(s.GetNext(pos));
		}
	}

	UpdateData(FALSE);
}

void CSusieDialog::OnButtonPluginSync() 
{
	UpdateData(TRUE);
	RefreshList();	
}
