

#include "stdafx.h"
#include "padie.h"
#include "SusiePlugin.h"
#include "OpenFileDialog.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CString SusiePluginPath;
HMODULE *SusiePlugins;
int SusiePluginsNum;
//---------------------------------------------------------------------------
void SetSusiePluginsInvalid(CStringList *lst)
{
	CString ini=AfxGetApp()->m_pszProfileName;
	char bf[30000];
	POSITION pos;
	int i=1,n;
	char *pt;

	pt=bf;

	for( pos = lst->GetHeadPosition(); pos != NULL; )
	{
		n=sprintf(pt,"%d=%s",i++,lst->GetNext(pos));
		pt+=(n+1);
	}
	*pt='\0';
	WritePrivateProfileSection("Plugins",bf,ini);
}
//---------------------------------------------------------------------------
void GetSusiePluginsInvalid(CStringList *lst,CString path)
{
	CString ini=AfxGetApp()->m_pszProfileName;
	char bf[30000];
	char *pt;
	unsigned char *rpt;
	long sz;
	CStringList sl;
//	CString s;

	GetSusiePluginsEnum(&sl,path);
	lst->RemoveAll();
	sz=GetPrivateProfileSection("Plugins",bf,30000,ini);
	if (sz) {
		pt=bf;
		while (*pt) {
			rpt=_mbschr((unsigned char *)pt,'=');
			if (rpt) {
				rpt++;
				if (sl.Find((char*)rpt)) lst->AddHead(rpt);
				while (*pt++);
			}
			else break;
		}
	}
}
//---------------------------------------------------------------------------
void GetSusiePluginsValid(CStringList *lst,CString path)
{
	CStringList sl;
	CString s;
	POSITION pos,fpos;

	GetSusiePluginsEnum(lst,path);
	GetSusiePluginsInvalid(&sl,path);
	for( pos = sl.GetHeadPosition(); pos != NULL; ) {
		s=sl.GetNext(pos);
		fpos=lst->Find(s);
		if (fpos) lst->RemoveAt(fpos);
	}
}

//---------------------------------------------------------------------------
static int PASCAL ProgressCallback(int ,int ,long )
{
	return 0;
}
//---------------------------------------------------------------------------
HDIB GetSusiePicture(LPCTSTR fname)
{
	char *ci,*cm,buffer[2048];
	typedef int (WINAPI *IsSupported_t)(LPCSTR , DWORD);
	IsSupported_t IsSupported;
	typedef int  (WINAPI *GetPicture_t)(LPCSTR ,long ,unsigned int 
		,HANDLE *,HANDLE *,FARPROC ,long );
	GetPicture_t GetPicture;

	HANDLE hbm,hbi;
	HFILE fh;
	HDIB ans;
	int i,a,cn=0,x,y,mac;
	long l1,l2,wb=0;
	unsigned char *pt;

	fh=_lopen(fname,OF_READ);
	if (fh==HFILE_ERROR) return false;
	memset(buffer,0,2048);
    _lread(fh,buffer,2048);
    _lclose(fh);

	ans=NULL;
	for (i=0;i<SusiePluginsNum;i++) {
		IsSupported=(IsSupported_t) ::GetProcAddress(SusiePlugins[i],"IsSupported");
		{
            mac=0;
			a=(IsSupported)(fname,(DWORD)buffer);
            if (a==0) a=(IsSupported)(fname,(DWORD)buffer+(mac=128));
			if (a!=0) {
				GetPicture=(GetPicture_t) ::GetProcAddress(SusiePlugins[i],"GetPicture");
				if (GetPicture!=NULL) {
					a=(GetPicture)(fname,mac,0,&hbi,&hbm,(FARPROC)ProgressCallback,0);
					if (a==0) {
						ci=(char *) ::LocalLock(hbi);
						cm=(char *) ::LocalLock(hbm);
						x=*(int *)(ci+4);
						y=*(int *)(ci+8);
						switch (*(short int *)(ci+14)) {
						   	case 1: cn=2;
								wb=((x+7)/8+3) & ~3;
								break;
							case 4: cn=16;
								wb=((x+1)/2+3) & ~3;
								break;
							case 8: cn=256;
								wb=(x+3) & ~3;
								break;
							case 16: cn=3;
								wb=((x*2)+3) & ~3;
								break;
							case 24: cn=0;
								wb=((x*3)+3) & ~3;
								break;
							case 32: cn=3;
								wb=((x*4)+3) & ~3;
								break;
						}
						l1=*((DWORD *)ci) +cn*sizeof(RGBQUAD);
						l2=*(DWORD *)(ci+20);
						if (l2==0) l2=wb*y;
                        *(DWORD *)(ci+32)=0;
                        *(DWORD *)(ci+36)=0;

						ans=(HDIB) ::GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT,l1+l2+sizeof(RGBQUAD)*256);
						pt=(unsigned char*) ::GlobalLock((HGLOBAL) ans);
						memcpy(pt,ci,l1);
						memcpy(pt+l1,cm,l2);
						::GlobalUnlock(ans);

						LocalFree(hbi);
						LocalFree(hbm);
						i=SusiePluginsNum; // loop out
					}
				}
			}
		}
	}
	return ans;
}
//---------------------------------------------------------------------------
void GetSusiePluginsEnum(CStringList *lst,CString path)
{
	HANDLE h;
	_WIN32_FIND_DATAA f;
	CString paths;

	FileAddYen(path);
	lst->RemoveAll();
	paths=path+"*.spi";

	h=FindFirstFile(paths,&f);
	if (h!=INVALID_HANDLE_VALUE) {
		do {
			lst->AddTail(f.cFileName);
		} while (FindNextFile(h,&f)==TRUE);
		FindClose(h);
	}
}
//---------------------------------------------------------------------------
void LoadSusiePlugins(void)
{
	HMODULE plugin;
	typedef int (WINAPI *GetPluginInfo_t)(int, LPSTR, int);
	GetPluginInfo_t GetPluginInfo;
	char bf[16];
	CStringList lst,dlst;
	int c,k;
	POSITION pos;

	FileAddYen(SusiePluginPath);
    GetSusiePluginsValid(&lst);

	c=lst.GetCount();
	SusiePlugins=new HMODULE [c];

	SusiePluginsNum=0;
	for( pos = lst.GetHeadPosition(); pos != NULL; ) {
		plugin=::LoadLibrary(SusiePluginPath+lst.GetNext(pos));
		if (plugin!=NULL) {
			GetPluginInfo=(GetPluginInfo_t)GetProcAddress(plugin,"GetPluginInfo");
			if (GetPluginInfo!=NULL) {
				k=(GetPluginInfo)(0,bf,10);
				bf[k]=0;
				if (CString(bf).Mid(2,2)=="IN") {
					SusiePlugins[SusiePluginsNum++]=plugin;
				}
				else FreeLibrary(plugin);
			}
		}
	}
}

//---------------------------------------------------------------------------
void FreeSusiePlugins(void)
{
	int i;

	for (i=0;i<SusiePluginsNum;i++) ::FreeLibrary((HMODULE)(SusiePlugins[i]));
	if (SusiePlugins!=NULL) delete [] SusiePlugins;
	SusiePlugins=NULL;
}
//---------------------------------------------------------------------------






