// DivideBox.h: CDivideBox NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIVIDEBOX_H__0BB39CE7_AB20_11D3_9BF6_00C0DFC4A6B8__INCLUDED_)
#define AFX_DIVIDEBOX_H__0BB39CE7_AB20_11D3_9BF6_00C0DFC4A6B8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "ColorSpace.h"

struct RMA {
	double x,y,z,c;
};

struct MED {
	GCS gcs;
	int cnt;
	double flag;
//	int flag;
};

struct MEDBOX {
	double strain;
	int bufstart,bufnum;
	GCS mid;
	int rgb;

	RMA prin,std,avg;
	double firstd;
};

class CDivideBox  
{
public:
	bool divideBox(MEDBOX *medbox,MED **medbuf,int mxa,int oi,CColorSpace *cs);
	void makeMEDbox(MEDBOX *medbox,MED **medbuf,int ad,int bs,int bn,CColorSpace *cs);
//	double dsqr(double a) const { return a*a; };
	CDivideBox();
	virtual ~CDivideBox();

protected:
	double setrma(MED **medbuf,int bs,int bn,RMA *prin,RMA *std,RMA *avg);
	void jacobi(int n, double a[3][3],double u[3][3], double eps);
	int FindSquareDiv(MED **ix,int st,int n);
	double jca[3][3],jcw[3][3];
};

#endif // !defined(AFX_DIVIDEBOX_H__0BB39CE7_AB20_11D3_9BF6_00C0DFC4A6B8__INCLUDED_)
