// PadieDoc.h : CPadieDoc NX̐錾уC^[tFCX̒`܂B
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PADIEDOC_H__2AA7506C_A283_11D3_9BF6_00C0DFC4A6B8__INCLUDED_)
#define AFX_PADIEDOC_H__2AA7506C_A283_11D3_9BF6_00C0DFC4A6B8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "dibapi.h"
#include "SusiePlugin.h"

class CPadieDoc : public CDocument
{
	friend CMainFrame;

protected: // VACY@\݂̂쐬܂B
	CPadieDoc();
	DECLARE_DYNCREATE(CPadieDoc)

// Agr[g
public:
	HDIB GetHDIB() const
		{ return m_hDIB; }
	CPalette* GetDocPalette() const
		{ return m_palDIB; }
	CSize GetDocSize() const
		{ return m_sizeDoc; }
	CSize GetViewSize() const
	{
		return CSize(ViewConvert(m_sizeDoc.cx),ViewConvert(m_sizeDoc.cy));
	}
	int ViewConvert(int i) const
	{
		if (m_nView>0) return i*m_nView;
		else return i>>(1-m_nView);
	}
	int ViewInverse(int i) const
	{
		if (m_nView>0) return i/m_nView;
		else return i<<(1-m_nView);
	}

	void QuantThreadDone();

	CGraphArray m_GraphArray;

// Iy[V
public:

//I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CPadieDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL CanCloseFrame(CFrameWnd* pFrame);
	//}}AFX_VIRTUAL

// Cve[V
public:
	BOOL m_CanQuant;
	BOOL m_Lock;
	void StuffDocument(HDIB hDib);
	int m_nView;
	void InitDIBData();
	void ReplaceHDIB(HDIB hDIB);
	virtual ~CPadieDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	HDIB m_hDIB;
	CPalette* m_palDIB;
	CSize m_sizeDoc;
//	CSize m_sizeView;


// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CPadieDoc)
	afx_msg void OnEditProperty();
	afx_msg void OnDoQuant();
	afx_msg void OnFileSaveAs();
	afx_msg void OnFileOpen();
	afx_msg void OnUpdateDoQuant(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_PADIEDOC_H__2AA7506C_A283_11D3_9BF6_00C0DFC4A6B8__INCLUDED_)
