// PadieView.cpp : CPadieView NX̓̒`s܂B
//

#include "stdafx.h"
#include "Padie.h"
#include "MainFrm.h"
#include "folder.h"
#include "PadieDoc.h"
#include "PadieView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPadieView

IMPLEMENT_DYNCREATE(CPadieView, CScrollView)

BEGIN_MESSAGE_MAP(CPadieView, CScrollView)
	//{{AFX_MSG_MAP(CPadieView)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_COMMAND(ID_ZOOM_ACT, OnZoomAct)
	ON_COMMAND(ID_ZOOM_IN, OnZoomIn)
	ON_COMMAND(ID_ZOOM_OUT, OnZoomOut)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_ERASEBKGND()
	ON_MESSAGE(WM_RESIZE_TO_FIT, OnResizeToFit)
	ON_MESSAGE(WM_DOREALIZE, OnDoRealize)
	ON_UPDATE_COMMAND_UI(ID_ZOOM_IN, OnUpdateZoomIn)
	ON_UPDATE_COMMAND_UI(ID_ZOOM_OUT, OnUpdateZoomOut)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPadieView NX̍\z/

CPadieView::CPadieView()
{
	m_MousePush=FALSE;
	m_cGrab=LoadCursor(NULL,IDC_SIZEALL);
}

CPadieView::~CPadieView()
{
}

/////////////////////////////////////////////////////////////////////////////
// CPadieView NX̕`

void CPadieView::OnDraw(CDC* pDC)
{
	CPadieDoc* pDoc = GetDocument();

	HDIB hDIB = pDoc->GetHDIB();
	if (hDIB != NULL)
	{
/*
		LPSTR lpDIB = (LPSTR) ::GlobalLock((HGLOBAL) hDIB);
		int cxDIB = (int) ::DIBWidth(lpDIB);         // DIB ̃TCY - x
		int cyDIB = (int) ::DIBHeight(lpDIB);        // DIB ̃TCY - y
		::GlobalUnlock((HGLOBAL) hDIB);
*/
		//s[sOGA
		CPoint cntr,tl=GetScrollPosition();
		RECT rct,real;
		GetClientRect(&rct);
		real.top     = tl.y;
		real.left    = tl.x;
		real.right   = (rct.right  - rct.left )+ tl.x;
		real.bottom  = (rct.bottom - rct.top  )+ tl.y;

		//Z^O
		cntr=CPoint(0,0);
		if (real.right-real.left >pDoc->GetViewSize().cx ) {
			cntr.x=(real.right+real.left-pDoc->GetViewSize().cx)/2;
		}
		if (real.bottom-real.top >pDoc->GetViewSize().cy ) {
			cntr.y=(real.bottom+real.top-pDoc->GetViewSize().cy)/2;
		}


		//\[X`
		CRect rcDIB;
		rcDIB.top    = pDoc->ViewInverse(real.top);
		rcDIB.left   = pDoc->ViewInverse(real.left);
		rcDIB.right  = pDoc->ViewInverse(real.right);
		rcDIB.bottom = pDoc->ViewInverse(real.bottom);

		if (rcDIB.right > pDoc->GetDocSize().cx) {
			rcDIB.right=pDoc->GetDocSize().cx;
			real.right=pDoc->ViewConvert(rcDIB.right);
		}
		if (rcDIB.bottom > pDoc->GetDocSize().cy) {
			rcDIB.bottom=pDoc->GetDocSize().cy;
			real.bottom=pDoc->ViewConvert(rcDIB.bottom);
		}

		//ö
		CRect rcDest=real;

		//␳
		rcDest.top   = min(real.top,pDoc->ViewConvert(rcDIB.top));
		if (real.bottom > pDoc->ViewConvert(rcDIB.bottom)) {
			rcDIB.bottom++;
			rcDest.bottom=pDoc->ViewConvert(rcDIB.bottom);
		}
		
		rcDest.left  = min(real.left,pDoc->ViewConvert(rcDIB.left));
		if (real.right > pDoc->ViewConvert(rcDIB.right))  {
			rcDIB.right++;
			rcDest.right=pDoc->ViewConvert(rcDIB.right);
		}


		rcDest+=cntr;
		::PaintDIB(pDC->m_hDC, &rcDest, pDoc->GetHDIB(),
			&rcDIB, pDoc->GetDocPalette());
	}
}

void CPadieView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();
	ASSERT(GetDocument() != NULL);

	SetScrollSizes(MM_TEXT, GetDocument()->GetDocSize());

	GetParentFrame()->RecalcLayout();
	ResizeParentToFit(FALSE) ;

}

/////////////////////////////////////////////////////////////////////////////
// CPadieView NX̐ff

#ifdef _DEBUG
void CPadieView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CPadieView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CPadieDoc* CPadieView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPadieDoc)));
	return (CPadieDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPadieView NX̃bZ[W nh
// pbg
LRESULT CPadieView::OnDoRealize(WPARAM wParam, LPARAM)
{
	ASSERT(wParam != NULL);
	CPadieDoc* pDoc = GetDocument();
	if (pDoc->GetHDIB() == NULL)
		return 0L;  // VKhLg

	CPalette* pPal = pDoc->GetDocPalette();
	if (pPal != NULL)
	{
		CMainFrame* pAppFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
		ASSERT_KINDOF(CMainFrame, pAppFrame);

		CClientDC appDC(pAppFrame);
		// ׂẴr[̓ 1 ͔wip̃pbgłB
		// wParam ̓ANeBuȃr[̃nh܂ނ̂ŁASelectPalette
		// bForceBackground tO wParam == m_hWnd (̃r[) ̏ꍇ FALSE łB 
		CPalette* oldPalette = appDC.SelectPalette(pPal, ((HWND)wParam) != m_hWnd);

		if (oldPalette != NULL)
		{
			UINT nColorsChanged = appDC.RealizePalette();
			if (nColorsChanged > 0)
				pDoc->UpdateAllViews(NULL);
			appDC.SelectPalette(oldPalette, TRUE);
		}
		else
		{
			TRACE0("\tSelectPalette failed in CPadieView::OnPaletteChanged\n");
		}
	}

	return 0L;
}
void CPadieView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
	CScrollView::OnActivateView(bActivate, pActivateView, pDeactiveView);

	if (bActivate)
	{
		ASSERT(pActivateView == this);
		OnDoRealize((WPARAM)m_hWnd, 0);   // SendMessage(WM_DOREALIZE) Ɠl;
	}
}
///////////////////////////////////////////////////////////////////////


void CPadieView::OnEditCopy() 
{

	CPadieDoc* pDoc = GetDocument();
	// Nbv{[h̓e DIB Rs[܂B

	if (OpenClipboard())
	{
		BeginWaitCursor();
		EmptyClipboard();
		SetClipboardData (CF_DIB, CopyHandle((HANDLE) pDoc->GetHDIB()) );
		CloseClipboard();
		EndWaitCursor();
	}
}

void CPadieView::OnUpdateEditCopy(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(GetDocument()->GetHDIB() != NULL);
}



LRESULT CPadieView::OnResizeToFit(WPARAM /*wParam*/, LPARAM)
{
	ResizeParentToFit(FALSE) ;
	return 0L;
}


///////////////////////////////////////////////////////////////////////
// Y[
void CPadieView::OnZoomAct() 
{
	GetDocument()->m_nView=1;
	SetScrollSizes(MM_TEXT, GetDocument()->GetViewSize());
	if (!((CMDIChildWnd*)GetParent())->IsZoomed()) {
		ResizeParentToFit(FALSE) ;
	}
	InvalidateRect(NULL,TRUE);
}

void CPadieView::OnZoomIn() 
{
	if (GetDocument()->m_nView<16) {
		GetDocument()->m_nView++;
		SetScrollSizes(MM_TEXT, GetDocument()->GetViewSize());
		if (!((CMDIChildWnd*)GetParent())->IsZoomed()) {
			ResizeParentToFit(FALSE) ;
		}
		InvalidateRect(NULL,TRUE);
	}
}
void CPadieView::OnUpdateZoomIn(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( (GetDocument()->m_nView<16) ? TRUE: FALSE);	
}

void CPadieView::OnZoomOut() 
{
	if (GetDocument()->m_nView>-4) {
		GetDocument()->m_nView--;
		SetScrollSizes(MM_TEXT, GetDocument()->GetViewSize());
		if (!((CMDIChildWnd*)GetParent())->IsZoomed()) {
			ResizeParentToFit(FALSE) ;
		}
		InvalidateRect(NULL,TRUE);
	}
}

void CPadieView::OnUpdateZoomOut(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( (GetDocument()->m_nView>-4) ? TRUE: FALSE);
}

void CPadieView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	CMDIChildWnd* f=(CMDIChildWnd*)GetParent();
	if (f->IsZoomed()) f->MDIRestore();
	else f->MDIMaximize();

	CScrollView::OnLButtonDblClk(nFlags, point);
}
///////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////
// 肸
void CPadieView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_MouseDrag=point;
	m_MousePush=TRUE;
	SetCapture();
	m_cOld=SetCursor(m_cGrab);

	CScrollView::OnLButtonDown(nFlags, point);
}

void CPadieView::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (m_MousePush) {
		CPoint d=GetScrollPosition()-point+m_MouseDrag;
		CSize  s=GetDocument()->GetViewSize();
		CRect rect; GetClientRect(&rect);
		 d.x=min(max(0,s.cx-rect.right ),max(d.x,0));
		 d.y=min(max(0,s.cy-rect.bottom),max(d.y,0));

		ScrollToPosition(d);
		m_MouseDrag=point;
	}
	
	CScrollView::OnMouseMove(nFlags, point);
}

void CPadieView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_MousePush=FALSE;
	ReleaseCapture();
	SetCursor(m_cOld);
//	InvalidateRect(NULL,FALSE);

	CScrollView::OnLButtonUp(nFlags, point);
}
///////////////////////////////////////////////////////////////////////

BOOL CPadieView::OnEraseBkgnd(CDC* pDC) 
{
#if (1)
	// bVobN
	CPoint p=CPoint(0,0)-GetScrollPosition();
	POINT tl=pDC->SetBrushOrg(p);

	COLORREF sc=GetSysColor(COLOR_BTNFACE);
	COLORREF mesh=RGB(
		GetRValue(sc)+( (GetRValue(sc)>=128)?-16:16 ),
		GetGValue(sc)+( (GetGValue(sc)>=128)?-16:16 ),
		GetBValue(sc)+( (GetBValue(sc)>=128)?-16:16 )
		);

	COLORREF oldColor=pDC->SetBkColor(GetSysColor(COLOR_BTNFACE));
	CBrush backBrush(HS_DIAGCROSS,mesh);
	CBrush* pOldBrush = pDC->SelectObject(&backBrush); 
/*
	CRect rect;
	pDC->GetClipBox(&rect); 
	pDC->PatBlt(rect.left, rect.top, rect.Width(), rect.Height(), PATCOPY); 
*/
	FillOutsideRect( pDC, &backBrush );
    

	pDC->SelectObject(pOldBrush); 
	pDC->SetBkColor(oldColor);
	pDC->SetBrushOrg(tl);
	return TRUE;
#else
	// \bhobN	
	CBrush backBrush(GetSysColor(COLOR_BTNFACE));
	CBrush* pOldBrush = pDC->SelectObject(&backBrush); 

	CRect rect;
	pDC->GetClipBox(&rect); 
	pDC->PatBlt(rect.left, rect.top, rect.Width(), rect.Height(), PATCOPY); 
	pDC->SelectObject(pOldBrush); 
	return TRUE;
#endif
	//	return CScrollView::OnEraseBkgnd(pDC);
}

void CPadieView::FillOutsideRect(CDC *pDC, CBrush *pBrush)
{
	ASSERT_VALID(pDC);
	ASSERT_VALID(pBrush);

	// fill rect outside the image
	CRect rect,r;
	GetClientRect(rect);
	ASSERT(rect.left == 0 && rect.top == 0);
	if (rect.right>m_totalDev.cx) {
		r=rect;
		r.right=(r.right-m_totalDev.cx)/2;
		if (!r.IsRectEmpty()) pDC->FillRect(r, pBrush);
		r=rect;
		r.left=(r.right-m_totalDev.cx)/2+m_totalDev.cx;
		if (!r.IsRectEmpty()) pDC->FillRect(r, pBrush);
	}
	if (rect.bottom>m_totalDev.cy) {
		if (rect.right>m_totalDev.cx) {
			rect.left=(r.right-m_totalDev.cx)/2;
			rect.right=(r.right-m_totalDev.cx)/2+m_totalDev.cx;
		}
		r=rect;
		r.bottom=(r.bottom-m_totalDev.cy)/2;
		if (!r.IsRectEmpty()) pDC->FillRect(r, pBrush);
		r=rect;
		r.top=(r.bottom-m_totalDev.cy)/2+m_totalDev.cy;
		if (!r.IsRectEmpty()) pDC->FillRect(r, pBrush);
	}
}

