// Quant.h: CQuant NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QUANT_H__936E9280_AB10_11D3_9BF6_00C0DFC4A6B8__INCLUDED_)
#define AFX_QUANT_H__936E9280_AB10_11D3_9BF6_00C0DFC4A6B8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "PadieDoc.h"
#include "ColorSpace.h"
#include "DivideBox.h"

//---------------------------------------------------------------------------

#define BARCO (0)
#define BARCR (20)
#define BARDO (20)
#define BARDR (80)
#define BAREO (100)
#define BARER (300)
#define BARFO (400)
#define BARFR (50)
#define BARAO (450)
#define BARAR (350)
#define BARBO (800)
#define BARBR (200)

#define CUBEX (40)
#define CUBEY (40)
#define CUBEZ (40)
#define CUBEZO (64*512*16)
#define CUBEALL (CUBEX*CUBEY*CUBEZ)
#define CUBEH (64*2560*16)
#define CUBESTEP (64*128*16)
#define CUBESTEPH (64*64*16)

	struct PALSTR {
		int c;
		int z;
	};

	struct Anime2line {
		int pal;
		int d;
	};

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class CQuant  
{



public:
	unsigned long m_CRC;

//---------------------------------------------------------------------------
int paletteprecision;
int CbMag;
int CrMag;
int CgMag;
int indexvolume;
int ditherlevel;
BOOL add16palette;
int picturemask;
int transparencycolor;
int dithermode;
HWND owner_handle;
//ProgressCallback pcallback;
//---------------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////
	MEDBOX medbox[768+1];
	GCS gcstable[256];
	MED *medbuf;
	MED** smedbuf;
int transpal;
	int *madepalette;
	unsigned char *palbuf;
	int *picbuf,*orgbuf;
	int picx,picy;
int gpsx,gpsy,gpsc;
int gpsdx,gpsdy,gpsdz;

int mxdx,mxdy,mxdz;
int makepalettenum;
short int *qcube[CUBEALL];
int trans;
//////////////////////////////////////////////////////////////////////

	void PostReturnMessage(void);
	void SetProgPos(int i);
	CPadieDoc* pvParam;
	CColorSpace cs;
	CDivideBox dv;
	int Execute(void);

	CQuant();
	virtual ~CQuant();

protected:
	void Bic(int m,int n,int a,int b,int c,int d);
	void Biscan(int width,int height);
	void Bit(int m,int n,int a,int b,int c,int d);
	void Transpose(int *a,int *b,int *c,int *d,int *e,int *f);
	void link(int a, int b);
	void Mtscan(int width,int height);
	int findClosepaletteSub(short int *p,int x,int y,int z);
	int findClosepalette(int x,int y,int z);
	void makecube(int x,int y,int z);
	int getCubeadr(int x,int y,int z);
};

#endif // !defined(AFX_QUANT_H__936E9280_AB10_11D3_9BF6_00C0DFC4A6B8__INCLUDED_)
