//  myfile.cpp
//
//  foCX CfByfg rbg}bv (DIB) API p̃\[Xt@CB
//  ȉ̊֐񋟂܂:
//
//  SaveDIB()           - t@CŎw肳ꂽ dib ۑ܂B
//  ReadDIBFile()       - t@C DIB [h܂B
//
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1998 Microsoft Corporation
// All rights reserved.
//
// ̃\[X R[h Microsoft Foundation Class t@XсA
// ֘AIC hLg̕⑫݂̂ړIƂĂ܂B
// Microsoft Foundation Class iɊւڂ͂̃hLg
// QƂĂB
//

#include "stdafx.h"
#include <math.h>
#include <io.h>
#include <direct.h>
#include "dibapi.h"

/*
 * Dib wb_[ [J[ - DIB t@C֏ލۂɎgp܂B
 */
#define DIB_HEADER_MARKER   ((WORD) ('M' << 8) | 'B')


/*************************************************************************
 *
 * SaveDIB()
 *
 * w肳ꂽ CFile ֎w肳ꂽ DIB ۑ܂B
 * CFile ͌ĂяoɂăI[vуN[Y܂B
 *
 * p[^:
 *
 * HDIB hDib - ۑp dib ւ̃nh
 *
 * CFile& file - open CFile  dib ̕ۑɎg܂B
 *
 * ߂l: Ȃ TRUEA ̑ FALSE ܂ CFileException
 *
 *************************************************************************/


BOOL WINAPI SaveDIB(HDIB hDib, CFile& file)
{
	BITMAPFILEHEADER bmfHdr; // rbg}bv t@Cp̃wb_[
	LPBITMAPINFOHEADER lpBI;   // DIB \̂ւ̃|C^
	DWORD dwDIBSize;

	if (hDib == NULL)
		return FALSE;

	/*
	 * DIB ւ̃|C^擾܂AԍŏɊ܂ł̂
	 * BITMAPINFO \̂łB
	 */
	lpBI = (LPBITMAPINFOHEADER) ::GlobalLock((HGLOBAL) hDib);
	if (lpBI == NULL)
		return FALSE;

	if (!IS_WIN30_DIB(lpBI))
	{
		::GlobalUnlock((HGLOBAL) hDib);
		return FALSE;       // ̃X^C DIB (ۑ̓T|[gĂ܂B)
	}

	/*
	 * t@C wb_[̃tB[h֏݂܂B
	 */

	/* t@C ^Cv̏ (rbg}bv̏ꍇ́Aŏ 2 oCg "BM" ɂȂ܂) */
	bmfHdr.bfType = DIB_HEADER_MARKER;  // "BM"

	// DIB ̃TCYvZ邱Ƃ͏X肪܂B (mɌvZ悤
	// ꍇł)B  łȒPȕ@̓O[o nh GlobalSize() 
	// яo@łAO[o ɂ͂炩̃oCgɃf[^Ă
	// \邽߁A]ȃoCgt@CɏŏI\
	// ܂(̃AvP[VŖN܂)B
	//
	// ̂߁ATCY(łȂ΁j蓮ŌvZ܂傤 B
	//
	// ŏɁAwb_[̃TCYƃJ[ e[ũTCY܂B
	// BITMAPINFOHEADER  BITMAPCOREHEADER ̍ŏ DWORD ͍\̂̃TCY
	// ł̂ŁAg܂傤B

	dwDIBSize = *(LPDWORD)lpBI + ::PaletteSize((LPSTR)lpBI);  // IȌvZ

	// C[W̃TCYvZ܂B

	if ((lpBI->biCompression == BI_RLE8) || (lpBI->biCompression == BI_RLE4))
	{
		//  RLE rbg}bvŁATCYvZłȂ̂ biSizeImage tB[h
		// MĎg܂B

		dwDIBSize += lpBI->biSizeImage;
	}
	else
	{
		DWORD dwBmBitsSize;  // rbg}bv rbĝ݂̃TCY

		//  RLE ł͂Ȃ̂ŁATCY͕(DWORD aligned) ~ łB

		dwBmBitsSize = WIDTHBYTES((lpBI->biWidth)*((DWORD)lpBI->biBitCount)) * lpBI->biHeight;

		dwDIBSize += dwBmBitsSize;

		// TCYvZł̂ŁAbiSizeImage tB[hɏ݂܂B
		//  (̃tB[hsɎĂ .BMP t@CC܂jB
		// 

		lpBI->biSizeImage = dwBmBitsSize;
	}


	// sizeof(BITMAPFILEHEADER)  DIB TCYZăt@C TCYvZ܂B

	bmfHdr.bfSize = dwDIBSize + sizeof(BITMAPFILEHEADER);
	bmfHdr.bfReserved1 = 0;
	bmfHdr.bfReserved2 = 0;

	/*
	 * t@Cł̎ۂ̃rbg}bv rbg̃ItZbgvZ܂B-- 
	 * rbg}bv t@C ̃wb_[  DIB wb_[ƃJ[ e[ũTCY
	 * ẐłB
	 */
	bmfHdr.bfOffBits = (DWORD)sizeof(BITMAPFILEHEADER) + lpBI->biSize
											  + PaletteSize((LPSTR)lpBI);

	TRY
	{
		// t@C wb_[݂܂B
		file.Write((LPSTR)&bmfHdr, sizeof(BITMAPFILEHEADER));
		//
		// DIB wb_[уrbg݂܂B
		//
		file.WriteHuge(lpBI, dwDIBSize);
	}
	CATCH (CFileException, e)
	{
		::GlobalUnlock((HGLOBAL) hDib);
		THROW_LAST();
	}
	END_CATCH


	::GlobalUnlock((HGLOBAL) hDib);
	return TRUE;
}


/*************************************************************************

  ֐:  ReadDIBFile (CFile&)

   pr:  w肳ꂽ DIB t@C̃O[o `N֓ǂݍ
		  ܂B

   ߂l:  ꍇ dib ւ̃nh (hDIB) Ԃ܂B
			G[ꍇ NULL Ԃ܂B

  Rg:  BITMAPFILEHEADER  DIB 菜܂B
			 BITMAPFILEHEADER \̂̏I肩ׂ̂Ă̂̂
			 O[o  nhŕԂ܂B

*************************************************************************/


HDIB WINAPI ReadDIBFile(CFile& file)
{
	BITMAPFILEHEADER bmfHeader;
	DWORD dwBitsSize;
	HDIB hDIB;
	LPSTR pDIB;

	/*
	 * ǂݍݎɎg߂ DIB ̒擾
	 */

	dwBitsSize = file.GetLength();

	/*
	 * DIB t@C wb_[ǂ݂ɍsAꂪLǂmF܂B
	 */
	if (file.Read((LPSTR)&bmfHeader, sizeof(bmfHeader)) != sizeof(bmfHeader))
		return NULL;

	if (bmfHeader.bfType != DIB_HEADER_MARKER)
		return NULL;

	/*
	 * DIB Ƀ蓖Ă܂B
	 */
	hDIB = (HDIB) ::GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT, dwBitsSize);
	if (hDIB == 0)
	{
		return NULL;
	}
	pDIB = (LPSTR) ::GlobalLock((HGLOBAL) hDIB);

	/*
	 * rbgǂݍ݂܂B
	 */
	if (file.ReadHuge(pDIB, dwBitsSize - sizeof(BITMAPFILEHEADER)) !=
		dwBitsSize - sizeof(BITMAPFILEHEADER) )
	{
		::GlobalUnlock((HGLOBAL) hDIB);
		::GlobalFree((HGLOBAL) hDIB);
		return NULL;
	}
	::GlobalUnlock((HGLOBAL) hDIB);
	return hDIB;
}


